"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.files$ = void 0;
const Rx = __importStar(require("rxjs"));
const RxOp = __importStar(require("rxjs/operators"));
const fs_1 = require("fs");
const glob = require("glob-to-regexp");
function files$(dir, opts = {}) {
    const { include, exclude } = opts;
    const includeRegExp = include ? glob(include, { globstar: true }) : undefined;
    const excludeRegExp = exclude ? glob(exclude, { globstar: true }) : undefined;
    return Rx.from(fs_1.promises.readdir(dir)).pipe(RxOp.flatMap((f) => f), RxOp.filter((f) => !f.startsWith(".")), RxOp.filter((f) => (include ? includeRegExp.test(f) : true)), RxOp.filter((f) => (exclude ? !excludeRegExp.test(f) : true)), RxOp.flatMap((file) => Rx.from(fs_1.promises.stat(`${dir}/${file}`)).pipe(RxOp.map((sf) => ({ file, isDir: sf.isDirectory() })))), RxOp.flatMap((f) => f.isDir ? files$(`${dir}/${f.file}`, opts) : Rx.of(`${dir}/${f.file}`)));
}
exports.files$ = files$;
